TTL equ " PC-9821Ap3/As3,An,Xn/Xs/Xp,Xe10, 9801BA3,BX3,BX4mCPUL1WBnV1.4 (C)2023 ܂ "
MSR_EFER        equ     0C0000080h
MSR_WHCR        equ     0C0000082h
MSR_UWCCR       equ     0C0000085h

CPU_WB_EN       equ     01h
L2C_EN          equ     02h
K6_WA_EN        equ     04h
K6_new_core     equ     08h
K6_old_core     equ     10h
K6_W15EN        equ     20h
CPUPentium      equ     40h
InIPLW          equ     80h

code            segment
                assume cs:code,ds:code,es:code,ss:code
                org 100h 
start:          jmp     begin
msg_Title       DB   0E5h,TTL,13,10,0,1Ah
align 4
Norm98GR_MTRR   DD      00000000000010111111111111111101b ; UC BFFFDh
Hires98GR_MTRR  DD      00000000000011011111111111111101b ; UC DFFFDh
Sys98F000_MTRR  DD      00000000000011111111111111111101b ; UC FFFFDh
MEMSIZE         DD      0
ROW             DW      9
COLUMN          DW      0
SegTVRAM        DW      0A000h
.386
begin:          
                xor     ax,ax
                mov     es,ax
                mov     flagset,al
                mov     ax,es:[0486h]   ; i[ꂽl`FbN
                mov     cpuid486,ax

                call    CheckInDOS

                mov     dx,offset msg_Title
                call    putstring
                mov     ax,cpuid486
                or      ax,ax           ; 0ȂÂ@
                jz      AbortProgram    ; Ȃ̂őI
.286
                smsw    ax
                test    ax,1            ; 286 Protected mode ɂ邩
                jz      in_real_mode       
.186
                mov     dx,offset msg_ProtectMode ; ʂ͉z86
                call    putstring
                jmp     ExitProgram

in_real_mode:
                mov     ax,cpuid486
                and     ax,0F00h        ; ODPƉʃrbg}XN
                cmp     ax,0300h        ; 0308hȏŉ\炵
                jbe     AbortProgram    ; 386,286,8086 @ł͑I
                cmp     ax,0400h        ; 80486݊CPU
                je      Machine486      ; ̃[`
                cmp     ax,0500h        ; PentiumȂ
                je      Machine586      ; ̃[`
                cmp     ax,0600h    ; P6@(Ra266+copper)łL1N
                jne     AbortProgram    ; ُȒl̂Ƃ͑I
MachineP6:   ;------------- P6 machines -----------
                or      flagset,CPUpentium  ; wbinvd,invdgp\tO𗧂Ă
                call    EnableCacheL1P5
                jmp     ExitProgram
Machine586:  ;------------- Pentium machines ------
                or      flagset,CPUpentium ; wbinvd,invdgp\tO𗧂Ă
                or      flagset,L2C_EN

                call    EnableCacheL1P5
                call    CheckMEM15M     ; Ԃ̃`FbN
                jc      ExitProgram
                mov     ax,cpuid486
                cmp     ax,0520h        ; cx686
                je      ExitProgram
                call    CheckAMD_K6NEW  ; CPUAMD, K6-2 VRAȏォǂH
                jc      ExitProgram
                test    flagset,K6_new_core   ; VRAtÕ`FbN
                jz      NotK6new
                call    set_MTRR_VGA98  ; 98OtBNXUC
;               VRȀꍇWrite combine̐ݒ肪邪 PCI@ł͍
                jmp     $+2
                jmp     $+2
                jmp     $+2
                mov     dx,offset msg_K6new
                call    putstring
                jmp     EndK6
NotK6new:
                test    flagset,K6_old_core
                jz      NotK6old
                mov     dx,offset msg_K6old
                call    putstring
NotK6old:
EndK6:
                jmp     ExitProgram

Machine486:  ; --- 486 machines ----------
                call    CheckWBE486     ; CgobN\CPUȂLɂ
                jmp     ExitProgram
;----------------------
AbortProgram:   mov     dx,offset msg_invalid
                call    putstring
ExitProgram:    
                mov     al,flagset
                and     al,0Fh
                or      al,al
                jnz     @f
                mov     dx,offset msg_none
                call    putstring
                
        @@:
                mov     dx,offset msg_CRLF
                call    putstring
                mov     cx,0FFF0h
                call    wait4
                
KeyLoopEnt:     mov     ah,2    ; VtgL[̊Ԃ̓[viPAUSEj
                int 18h
                test    al,1
                jnz     KeyLoopEnt
                test    flagset,InIPLW
                jz      WasInDOS
                RET     ; IPLware type2 Ȃ̂ RET ߂
WasInDOS:   ; DOS֖߂I
                mov     al,flagset      ; tOlԒl AX
;;              mov     ah,4Ch          ; int 21h
                RET     
;-----------------------------------------------

;-----------------------------------------------
wait4           PROC   near
DispLoopEnt:    out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
               Loop     DispLoopEnt
                ret
wait4           ENDP
;-----------------------------------------------
Beep            PROC   near
                push    ax
                push    cx
                mov     al,6
                out     37h,al
                mov     cx,111h
                call    wait4
                mov     al,7
                out     37h,al
                pop     cx
                pop     ax
                ret
Beep            ENDP
;-----------------------------------------------
CheckWBE486     PROC    near
                mov     ax,cpuid486
                mov     dx,offset msg_CPU04F4
                cmp     ax,04F4h        ; Am5x86 WB x4 speed
                je      wb_start
                mov     dx,offset msg_CPU0494
                cmp     ax,0494h        ; Am5x86 WB x3 speed 
                je      wb_start
                mov     dx,offset msg_CPU0490
                cmp     ax,0490h        ; WBE DX4-100 SK096
                je      wb_start
                mov     dx,offset msg_CPU0470
                cmp     bx,0470h        ; WBE DX2-66 SX955 
                je      wb_start
                mov     dx,offset msg_CPU0474
                cmp     ax,0474h        ; WBE AMD 486DX2WB
                je      wb_start
                mov     dx,offset msg_CPU0429
                cmp     ax,0429h        ; Cyrix 5x86 
                je      wb_start
                mov     dx,offset msg_CPU042D
                cmp     ax,042Dh        ; Cyrix 5x86 
                je      wb_start
                ret     ; LɂȂȂCPUɂ͉Ȃ
wb_start:       
                call    putstring
                call    Port063F
                ret
CheckWBE486     ENDP

;-----------------------------------------------
msg_CRLF        DB      0E1h,13,10,0
msg_ProtectMode DB      0C1h," z86[hł͎sł܂. EMM386ȂǂgȂŎsĂ.",13,10,0
msg_L1set       DB      0A1h," L1èނɂ܂.  ",0
msg_L1set2      DB      0E1h,"mL1Cn ",0
msg_K6old       DB      0E1h,"mK6 ײı۹ėLn ",0
msg_K6new       DB      0E1h,"mK6V ײı۹ėLn ",0
msg_CPU_051X    DB      0E1h,"mAMD K5-133RPn ",0
msg_CPU_052X    DB      0E1h,"mAMD K5-166RPn ",0
msg_CPU04F4     DB      0A1h,"mAMD 5x86 133MHzn ",0
msg_CPU0494     DB      0E1h,"mAMD 5x86 100MHzn ",0
msg_CPU0490     DB      061h,"mi486DX4 WBEn ",0
msg_CPU0470     DB      0E1h,"mi486DX2 WBEn ",0
msg_CPU0474     DB      0E1h,"mAMD 486DX2 WBn ",0
msg_CPU0429     DB      0E1h,"mCyrix Cx586n ",0
msg_CPU042D     DB      0E1h,"mCyrix Cx586n ",0
msg_CPU052D     DB      0E1h,"mCyrix Cx586n ",0
msg_CPUP55C     DB      0E1h,"mMMX Pentiumn ",0
if 0
msg_CPUP54C     DB      0E1h,"mPentiumn ",0
endif
msg_CheckWBE    DB      0E1h," ײޯ\ɂ܂. ",0
msg_invalid     DB      041h," ̋@ł͖ł. ",0
msg_none        DB      0E1h," Ƃɐݒ̕Kv܂.",13,10,0
;=============================================
.386
Port063F        PROC   near
                mov     dx,063Fh  ; 486@}U[{[h WBH
                in      al,dx
                cmp     al,0FFh ; FFȂ@\Ȃ
                jne     Exist063F
                stc     ; Ȃ
                ret
Exist063F:      
                mov     dx,043Fh
                mov     al,0A0h
                out     dx,al
                cli
                mov     eax,cr0
                or      eax,40000000h   ; L1 disabled,WT
                mov     cr0,eax
                sti

                mov     BL,10100000b    ; WB,L1     ; mod. 2023/10/30
                test    flagset,L2C_EN
                jz      @f
                mov     BL,10110000b    ; WB,L1,L2 
        @@:     
                mov     dx,063Fh  ; 486@}U[{[h WBH
                in      al,dx
                test    al,10000000b    ; bit7=WB/WT
                jnz     @f
                or      al,BL
                out     dx,al           ; bit7𗧂ĂĐݒ
        @@:     
                mov     al,0A0h ; LbVj
                mov     dx,043Fh
                out     dx,al
                cli
                mov     eax,cr0         ; Enable L1 Cache,WB
                and     eax,9FFFFFFFh
                mov     cr0,eax
                sti

                jmp     $+2     ; ߉̃vtFb`j
                or      flagset,CPU_WB_EN
                mov     dx,offset msg_CheckWBE
                call    putstring

                clc
                ret
Port063F        ENDP
;-----------------------------------------------
CheckMEM15M     PROC    near
                xor     eax,eax
                mov     ebx,eax

                mov     es,ax
                mov     al,es:[0401h]
                cmp     al,78h
                jne     @f
                or      flagset,K6_W15EN
        @@:     
                or      al,al
                jz      MemInvalid
                add     al,8    ; 1MB=8 (P:128KB)
                mov     bx,es:[0594h]   ; (P:MoCg)
                or      bx,bx
                jz      NotOver16M
                cmp     al,70h
                je      ConvertTo128K
                add     al,8    ; 1MB (as 15-16MB area)
ConvertTo128K:
                shl     bx,3    ; to 128KB
                add     ax,bx
NotOver16M:     
                shl     eax,17
                mov     MEMSIZE, eax
                mov     dx,8F1Eh        ;I/O	8F1Eh(\) bit 0: 16M 
                in      al,dx
                test    al,00000001b    ; 1= ؂(VXeŎgpȂ)jA
                jz      @f
                or      flagset,K6_W15EN
        @@:     
                or      flagset,K6_WA_EN
                clc
                ret
MemInvalid:     stc
                ret
CheckMEM15M     ENDP

;-------------------------------------------
CheckAMD_K6NEW  PROC    near
                xor     eax,eax
                cpuid   ; CPUID(0)
                cmp     ecx,'DMAc'      ; "Authentic AMD"
                jne     Not_K6
;AMD
                xor     eax,eax
                inc     ax
                cpuid   ; CPUID(1)
                mov     cx,ax
                mov     ebx,MEMSIZE
                and     ax,0FFFh     ; ŏʃ}XN
                and     cx,0FF0h
                mov     dx,offset msg_CPU_051X
                cmp     cx,0510h
                je      K5_WB
                mov     dx,offset msg_CPU_052X
                cmp     ax,0524h
                je      K5_WB

                cmp     ax,0560h     ; ӂK6
                jb      Not_K6
                cmp     ax,0588h     ; VRAK6̍ŏ
                jb      K6_old_wa
;K6_new_wa:
                mov     ecx,MSR_EFER    ; EEFR
                xor     eax,eax
                xor     edx,edx
                rdmsr
                or      al,00000110b ;          DATA_MSR_EFER=6
                wbinvd
                wrmsr
                jmp     $+2

                mov     ebx,MEMSIZE
                or      ebx,ebx
                jz      Not_K6
                or      flagset,K6_new_core
                test    flagset,K6_W15EN ; 15-16MBԂ̃LbV 1=en
                jz      Not16sysK6NEW    ; ɂȂĂɂ
                or      ebx,00000000000000010000000000000000b
Not16sysK6NEW:
                jmp     K6_ALL
K6_old_wa:      ; RAK6̂Ƃ
                mov     ebx,MEMSIZE
                or      ebx,ebx
                jz      Not_K6
                shr     ebx,21
                or      flagset,K6_old_core
                test    flagset,K6_W15EN
                jz      @f
                or      bl,00000001b
        @@:     
        
K6_ALL:      
                test    flagset,K6_new_core
                jz      @f
                call    Beep
        @@:
                pushf
                cli
                wbinvd
                mov     ECX,MSR_WHCR
                rdmsr
                mov     EAX,EBX
                wrmsr
                popf
                jmp     $+2
                clc
                ret
K5_WB:      ; Authentic Am5x86 K5
                call    putstring
                call    Port063F
                stc
                ret
Not_K6:         
                xor     eax,eax
                inc     ax
                cpuid   ; CPUID(1)
                
                and     ax,0FF0h
                cmp     ax,0540h
                jne     @f
                mov     dx,offset msg_CPUP55C
                call    putstring
                call    Port063F
        @@:     stc
                ret
CheckAMD_K6NEW  ENDP
;-----------------------------------------------

;-----------------------------------------------
EnableCacheL1P5 PROC   near
                mov     dx,043Fh
                mov     al,0A0h
                out     dx,al

                mov     eax,cr0
                test    eax,40000000h
                jz      CacheIsValid
                test    flagset,CPUpentium
                jz      @f
                wbinvd
        @@:
                pushf
                cli
                mov     dx,043Fh
                mov     al,0A0h
                out     dx,al
                mov     eax,cr0         ; Enable L1 Cache
                and     eax,9FFFFFFFh
                mov     cr0,eax
                popf
                test    flagset,CPUpentium
                jz      @f
                invd
        @@:     
                mov     dx,043Fh
                mov     al,0A0h
                mov     dx,offset msg_L1set
                call    putstring
                jmp     $+2
                ret
CacheIsValid:   
;               mov     dx,offset msg_L1set2
;               call    putstring
                ret
EnableCacheL1P5 ENDP
;-----------------------------------------------

set_MTRR_VGA98  PROC    near
                xor     eax,eax
                mov     es,ax
                test    byte ptr es:[501h],8
                jnz     Hires98Video
                mov     edx,Norm98GR_MTRR
                jmp     Both98Video
Hires98Video:   mov     edx,Hires98GR_MTRR
Both98Video:    
                pushf
                cli
                mov     ecx, MSR_UWCCR       ; set UWCCR as 98video 
                wrmsr
                popf
                ret
set_MTRR_VGA98  ENDP
.186
;===================================
include     putstr86.inc
;-----------------------------------
putstring       PROC   near
                test    flagset,InIPLW
                jz      putstringDOS
                call    _puts
                ret
putstringDOS:   
                mov     bx,dx
putstring_ent:  inc     bx
                mov     dl,[bx]
                or      dl,dl
                jz      EndOfString
                mov     cl,10h
                mov     ah,00h          ; mov     ah,2
                int     0DCh            ; int     21h
                jmp     putstring_ent
EndOfString:    
                ret
putstring       ENDP


CheckInDOS      PROC   near     ; ES=0
                mov     ax,cs
                cmp     ax,6000h        ; sZOgŔ
                je      ExecIPLW
                cmp     ax,7000h        ; sZOgŔIPLWUNI
                je      ExecIPLW
                ; IPLware DOSƌFƖ ̂QȊO͂
                mov     dl,es:[0501h]   ; nC]`FbN
                mov     ax,es:[21h*4+2] ; int 21h xN^`ȂDOS
                test    dl,8            ; nC]`FbN
                jz      @f
                mov     SegTVRAM,0E000h  ; VRAMR[ḧZOg
        @@:     
                cmp     ax,0060h        ; DOS̑݃ZOg 0060h͒ʏ
                je      ExecDOS
                cmp     ax,0436h        ; 436̂Ƃ?
                je      ExecDOS
                cmp     ax,0FFFFh       ; HMAɑ݂邩
                je      ExecDOS
ExecIPLW:       ; ȊÔƂ DOSIPLwareƌFĂ͏Ȃ
                or      flagset,InIPLW
                RET     ; IPLwareƔ肵Ė߂
ExecDOS:        
                
                RET     ; DOSƔ肵Ė߂
CheckInDOS      ENDP


align 2
cpuid486        DW      0
flagset         DB      0

code    ends
        end     start
